Attribute VB_Name = "DBTool"
' *** 萔` ***
' ftHg̏o͐fBNg
Public Const outputPath = "C:\work\temp\"
'******************

' SẴV[gɑ΂āACSV쐬
Sub createCSVALL()
    For Each Sheet In Sheets
        Sheet.Activate
        createCsvByFile (Sheet.Name)
    Next Sheet
End Sub

' SẴV[gɑ΂āAINSERTXNvg쐬
Sub createInsertScriptALL()
    For Each Sheet In Sheets
        Sheet.Activate
        createInsertScriptByFile (Sheet.Name)
    Next Sheet
End Sub

' CSV쐬Tu[`(ANeBuV[ggp)
Sub createCsv()
    Call createCsvByFile(ActiveSheet.Name)
End Sub

' InsertScript쐬Tu[`(ANeBuV[ggp)
Sub createInsertScript()
    Call createInsertScriptByFile(ActiveSheet.Name)
End Sub

' CSV쐬Tu[`
Sub createCsvByFile(fileName$)
    ' -- 萔` --
    ' ***************************************
    ' CSVpf[^擾邽߂̃x[XZ
    Set baseCell = Cells(2, 1)
    ' ***************************************

    ' CSVpf[^͈͂̓
    Set baseRegion = baseCell.CurrentRegion
    Set targetRange = Range(baseCell, Cells(baseRegion.Rows.Count, baseRegion.columns.Count))

    ' CSVt@Co[hŊJ
    Open outputPath & fileName & ".csv" For Output Access Write As #1

    ' CSVf[^̏o
    For Each Row In targetRange.Rows
        strLine = ""
        For cnt = 1 To Row.columns.Count
            strLine = strLine & Row.columns(cnt).Value
            
            ' ŏIsłȂꍇ́AJ}t^
            If cnt <> Row.columns.Count Then
                strLine = strLine & ","
            End If
        Next cnt
        Print #1, strLine
    Next Row

    Close #1
End Sub

' INSERT쐬Tu[`
Sub createInsertScriptByFile(fileName$)
    ' -- 萔` --
    ' ***************************************
    ' InsertScriptpf[^擾邽߂̃x[XZ
    Set baseCell = Cells(1, 1)
    ' ***************************************

    ' InsertScriptpf[^͈͂̓
    Set baseRegion = baseCell.CurrentRegion
    Set targetRange = Range(baseCell, Cells(baseRegion.Rows.Count, baseRegion.columns.Count))

    ' InsertScriptt@Co[hŊJ
    Open outputPath & fileName & ".sql" For Output Access Write As #1

    ' wb_̎擾
    strHeader = ""
    For headerCnt = 1 To targetRange.columns.Count
        strHeader = strHeader & targetRange(1, headerCnt).Value
        If headerCnt <> targetRange.columns.Count Then
            strHeader = strHeader & ","
        End If
    Next headerCnt

    ' InsertScriptf[^̏o
    rowCount = targetRange.Rows.Count
    columnCount = targetRange.columns.Count
    Print #1, "truncate table " & fileName & " "

    For i = 2 To rowCount
        strSQL = "INSERT INTO " & fileName & "(" & strHeader & ") values("
        
        For j = 1 To columnCount
            strSQL = strSQL & targetRange(i, j).Value
            If j <> columnCount Then
                strSQL = strSQL & ","
            End If
        Next j
        
        strSQL = strSQL & ")"
        Print #1, strSQL
    Next i

    Close #1
End Sub

' f[^C|[gTu[`
Sub importDataByFile(fileName$)
    Call importDataByFileByConStr(fileName, defaultConStr)
End Sub

' f[^C|[gTu[`
Sub importDataByFileByConStr(fileName$, conStr$)
    ' -- 萔` --
    ' ***************************************
    ' InsertScriptpf[^擾邽߂̃x[XZ
    Set baseCell = Cells(1, 1)
    ' ***************************************

    ' C|[gpf[^͈͂̓
    Set baseRegion = baseCell.CurrentRegion
    Set targetRange = Range(baseCell, Cells(baseRegion.Rows.Count, baseRegion.columns.Count))

    ' wb_̎擾
    strHeader = ""
    For headerCnt = 1 To targetRange.columns.Count
        strHeader = strHeader & targetRange(1, headerCnt).Value
        If headerCnt <> targetRange.columns.Count Then
            strHeader = strHeader & ","
        End If
    Next headerCnt

    ' DBڑ
    Set con = New ADODB.Connection
    con.Open conStr

    ' R[h폜
    con.Execute "delete from " & ActiveSheet.Name

    ' f[^̃C|[g
    rowCount = targetRange.Rows.Count
    columnCount = targetRange.columns.Count
    For i = 2 To rowCount
        strSQL = "INSERT INTO " & fileName & "(" & strHeader & ") values("
        
        For j = 1 To columnCount
            strSQL = strSQL & targetRange(i, j).Value
            If j <> columnCount Then
                strSQL = strSQL & ","
            End If
        Next j
        
        strSQL = strSQL & ")"
        con.Execute strSQL
    Next i

    ' f[^x[Xڑ̌n
    con.Close
End Sub

' f[^GNX|[gTu[`
Sub exportDataByFileByConStr(tableName$, conStr$, workBookTo As Workbook)
    Dim exportWorkbook As Workbook
    Dim exportWorkSheet As Worksheet
    Dim rst As Recordset
    Dim columns As Fields

    ' DBڑ
    Set con = New ADODB.Connection
    con.Open conStr
    
    ' f[^̎擾
    Set rst = New Recordset
    rst.Open "select * from " & tableName, con
    
    ' f[^ꍇ́ATu[`I
    If rst.EOF Or rst.BOF Then
        GoTo CleanUp
    End If
    
    ' GNX|[g̏
    Set exportWorkSheet = workBookTo.Sheets.Add
    exportWorkSheet.Name = tableName
    
    ' wb_̎擾ƃGNX|[g
    Set columns = rst.Fields
    For i = 0 To columns.Count - 1
        exportWorkSheet.Cells(1, i + 1).Value = columns(i).Name
    Next i

    ' f[^̃GNX|[g
    rowCount = 2
    Do Until rst.EOF
        For j = 0 To columns.Count - 1
            exportWorkSheet.Cells(rowCount, j + 1).Value = rst(j)
        Next j

        rst.MoveNext
        rowCount = rowCount + 1
    Loop

    ' f[^x[Xڑ̌n
CleanUp:
    rst.Close
    con.Close
End Sub

' Se[u擾֐
Function getALLTables(conStr As String) As Collection
    Dim result As New Collection
    
    Dim con As New ADODB.Connection
    Dim rs As ADODB.Recordset

    ' f[^x[Xւ̐ڑ
    con.Open conStr

    ' Se[u擾
    Set rs = con.OpenSchema(adSchemaTables, Array(Empty, Empty, Empty, "TABLE"))
    Do Until rs.EOF
        result.Add (rs("TABLE_NAME"))
        rs.MoveNext
    Loop

    ' f[^x[Xڑ̌n
    rs.Close
    con.Close

    ' ʂ̕ԋp
    Set getALLTables = result
End Function
