Attribute VB_Name = "DBToolForAccess"
' for Access
Public Const conStrBaseAccess = "Provider=MSDASQL"
Public Const strAccessDriverName = "{Microsoft Access Driver (*.mdb)}"

' SẴV[gɑ΂āA_CAOŎw肵mdbt@CɁAf[^C|[gs
Sub importDataALLForAccess()
    Dim strFileName As String
    Dim conStr As String

    ' f[^x[Xڑ
    strFileName = Application.GetOpenFilename
    conStr = structureConnectStringForAccess(strFileName)

    For Each Sheet In Sheets
        Sheet.Activate
        Call DBTool.importDataByFileByConStr(Sheet.Name, conStr)
    Next Sheet
End Sub

' _CAOŎw肵mdbt@CɁAf[^C|[gs
Sub importDataForAccess()
    Dim strFileName As String
    Dim conStr As String

    ' f[^x[Xڑ
    strFileName = Application.GetOpenFilename
    conStr = structureConnectStringForAccess(strFileName)

    For Each Sheet In ActiveWindow.SelectedSheets
        Call DBTool.importDataByFileByConStr(Sheet.Name, conStr)
    Next Sheet
End Sub

' SẴe[uɑ΂āA_CAOŎw肵mdbt@CAf[^GNX|[gs
Sub exportDataALLForAccess()
    Dim strFileName As String
    Dim conStr As String
    Dim allTables As Collection
    Dim strTableName As String
    Dim workBookTo As Workbook
    
    ' f[^x[Xڑ
    strFileName = Application.GetOpenFilename
    conStr = structureConnectStringForAccess(strFileName)
    Set workBookTo = Workbooks.Add

    ' Se[uɑ΂ăGNX|[g
    Set allTables = DBTool.getALLTables(conStr)
    For Each tableName In allTables
        strTableName = tableName
        Call DBTool.exportDataByFileByConStr(strTableName, conStr, workBookTo)
    Next tableName
End Sub

' _CAOŎw肵mdbt@CAf[^GNX|[gs
Sub exportDataForAccess()
    Dim strFileName As String
    Dim conStr As String
    Dim strTableName As String
    Dim workBookTo As Workbook

    ' f[^x[Xڑ
    strFileName = Application.GetOpenFilename
    conStr = structureConnectStringForAccess(strFileName)
    strTableName = Application.InputBox("GNX|[ge[u͂ĉ")
    Set workBookTo = Workbooks.Add

    ' we[uɑ΂ăGNX|[g
    Call DBTool.exportDataByFileByConStr(strTableName, conStr, workBookTo)
End Sub

' ADOڑ쐬֐ (for Access)
Function structureConnectStringForAccess(fileName$)
    structureConnectStringForAccess = conStrBaseAccess & "; Driver=" & strAccessDriverName & "; DBQ=" & fileName
End Function
