Attribute VB_Name = "DBToolForSQLServer"
' for SQLServer
Public Const conStrBaseSQLServer = "Provider=SQLOLEDB.1"

' SQLServerւ̐ڑ
Type DBConnectInfo
    serverName As String
    dataBaseName As String
    userName As String
End Type

' SẴV[gɑ΂āA_CAOŎw肵T[o[Af[^x[XɁAw胆[UŃf[^C|[gs
Sub importDataALLForSQLServer()
    Dim dbInfo As DBConnectInfo
    Dim conStr As String
    dbInfo = inputDataBaseInfo()
    conStr = structureConnectStringForSQLServer(dbInfo.serverName, dbInfo.dataBaseName, dbInfo.userName)

    For Each Sheet In Sheets
        Sheet.Activate
        Call DBTool.importDataByFileByConStr(Sheet.Name, conStr)
    Next Sheet
End Sub

' _CAOŎw肵T[o[Af[^x[XɁAw胆[UŃf[^C|[gs
Sub importDataForSQLServer()
    Dim dbInfo As DBConnectInfo
    Dim conStr As String
    
    dbInfo = inputDataBaseInfo()
    conStr = structureConnectStringForSQLServer(dbInfo.serverName, dbInfo.dataBaseName, dbInfo.userName)
    
    For Each Sheet In ActiveWindow.SelectedSheets
        Call DBTool.importDataByFileByConStr(Sheet.Name, conStr)
    Next Sheet
End Sub

' SẴe[uɑ΂āA_CAOŎw肵T[o[Af[^x[XA
' w胆[UŃf[^GNX|[gs
Sub exportDataALLForSQLServer()
    Dim dbInfo As DBConnectInfo
    Dim conStr As String
    Dim strTableName As String
    Dim allTables As Collection
    Dim workBookTo As Workbook
    
    ' f[^x[Xڑ
    dbInfo = inputDataBaseInfo()
    conStr = structureConnectStringForSQLServer(dbInfo.serverName, dbInfo.dataBaseName, dbInfo.userName)
    
    ' GNX|[g惏[NubNp
    Set workBookTo = Workbooks.Add

    ' Se[uɑ΂ăGNX|[g
    Set allTables = DBTool.getALLTables(conStr)
    For Each tableName In allTables
        strTableName = tableName
        Call DBTool.exportDataByFileByConStr(strTableName, conStr, workBookTo)
    Next tableName
End Sub

' _CAOŎw肵T[o[Af[^x[XAw胆[UŃf[^GNX|[gs
Sub exportDataForSQLServer()
    Dim dbInfo As DBConnectInfo
    Dim conStr As String
    Dim strTableName As String
    Dim workBookTo As Workbook
    
    ' f[^x[Xڑ̓
    dbInfo = inputDataBaseInfo()
    conStr = structureConnectStringForSQLServer(dbInfo.serverName, dbInfo.dataBaseName, dbInfo.userName)

    ' GNX|[ge[u̓
    strTableName = Application.InputBox("GNX|[ge[u͂ĉ")

    ' GNX|[g惏[NubNp
    Set workBookTo = Workbooks.Add

    ' f[^GNX|[g
    Call DBTool.exportDataByFileByConStr(strTableName, conStr, workBookTo)
End Sub

' ADOڑ쐬֐ (for SQLServer)
Function structureConnectStringForSQLServer(serverName$, dataBaseName$, userName$)
    structureConnectStringForSQLServer = conStrBaseSQLServer & _
                                         "; User ID=" & userName & _
                                         "; Initial Catalog=" & dataBaseName & _
                                         "; Data Source=" & serverName
End Function

' f[^x[Xڑ̓͊֐
Function inputDataBaseInfo() As DBConnectInfo
    Dim dbInfo As DBConnectInfo

    dbInfo.serverName = Application.InputBox("T[o͂ĉ")
    dbInfo.dataBaseName = Application.InputBox("f[^x[X͂ĉ")
    dbInfo.userName = Application.InputBox("[U͂ĉ")

    inputDataBaseInfo = dbInfo
End Function
